//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <assert.h>
#pragma hdrstop

#include "NewBkg.h"

#if (__BORLANDC__ >= 0x0530)
//---------------------------------------------------------------------------
// BCB 3.0
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//
static inline void ValidCtrCheck(TNewBkg *)
{
    new TNewBkg(NULL);
}
//---------------------------------------------------------------------------
__fastcall TCustomNewBkg::TCustomNewBkg(TComponent* Owner)
	: TComponent(Owner)
{
  NewHookFormProc = NULL;
  FBkgOwner = NULL;
  HookForm();
}
//---------------------------------------------------------------------------
__fastcall TCustomNewBkg::~TCustomNewBkg()
{
  UnhookForm();
}
//---------------------------------------------------------------------------
void __fastcall TCustomNewBkg::SetOwner( TWinControl *Owner )
{
  if ( Owner != FBkgOwner )
    {
    UnhookForm();
    FBkgOwner = (TWinControl *) Owner;
    HookForm();
    }
}
//---------------------------------------------------------------------------
void __fastcall TCustomNewBkg::HookForm()
{
  if ( FBkgOwner )
    {
    OwnerHandle = FBkgOwner->Handle;

    OldHookFormProc = (int (__stdcall *)()) GetWindowLong(OwnerHandle, GWL_WNDPROC);
    NewHookFormProc = (int (__stdcall *)()) MakeObjectInstance(HookFormProc);

    SetWindowLong(OwnerHandle, GWL_WNDPROC, (long) NewHookFormProc);
    }
}
//---------------------------------------------------------------------------
void __fastcall TCustomNewBkg::UnhookForm()
{
  if ( NewHookFormProc )
    {
    SetWindowLong(OwnerHandle, GWL_WNDPROC, (long) OldHookFormProc);
    if (NewHookFormProc)
      FreeObjectInstance(NewHookFormProc);

    NewHookFormProc = NULL;
    }
}
//---------------------------------------------------------------------------
void __fastcall TCustomNewBkg::HookFormProc( TMessage &aMsg )
{
  if ( aMsg.Msg == WM_ERASEBKGND )
    {
    if ( FOnEraseBackground )
      FOnEraseBackground ( this, FBkgOwner );
    }

  else
    aMsg.Result = CallWindowProc(OldHookFormProc, OwnerHandle,
                                   aMsg.Msg, aMsg.WParam, aMsg.LParam);
}
//---------------------------------------------------------------------------
namespace Newbkg
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TNewBkg)};
		RegisterComponents("BMitov", classes, 0);
	}
}
//---------------------------------------------------------------------------
